---
# tasks file for dirvish

- name: Create the SSH key pair
  openssh_keypair:
    path: /root/.ssh/id_rsa
    owner: root
    group: root
    mode: 0600
    comment: backup.freexian.com
  register: dirvish_ssh_key

- name:
  debug:
    msg: "The public SSH key to configure on clients is this one: {{ dirvish_ssh_key.public_key }}"

- name: Install the dirvish package
  apt:
    name: dirvish

- name: Setup dirvish's master.conf
  template:
    dest: /etc/dirvish/master.conf
    src: master.conf
    owner: root
    mode: 0644
    backup: True

- name: Create the vaults
  file:
    path: '{{ item.bank|default(dirvish_banks[0]) }}/{{ item.name }}/dirvish'
    state: directory
    mode: 0755
    owner: root
    group: root
  loop: '{{ dirvish_vaults }}'
  loop_control:
    label: '{{ item.name }}:{{ item.branch|default("default") }}'

- name: Configure the vaults
  template:
    dest: '{{ item.bank|default(dirvish_banks[0]) }}/{{ item.name }}/dirvish/{{ item.branch|default("default") }}.conf'
    src: vault.conf
    owner: root
    mode: 0644
    backup: True
  loop: '{{ dirvish_vaults }}'
  loop_control:
    label: '{{ item.name }}:{{ item.branch|default("default") }}'

- name: Initialize the vault by running the first backup
  shell:
    cmd: "dirvish --vault {{ item.name }}:{{ item.branch|default('default') }} --image init-{{ item.branch|default('default') }} --init || (rm -rf {{ item.bank|default(dirvish_banks[0]) }}/{{ item.name }}/init-{{ branch|default('default') }}; false)"
    creates: "{{ item.bank|default(dirvish_banks[0]) }}/{{ item.name }}/dirvish/{{ item.branch|default('default') }}.hist"
  tags: dirvish-init
  loop: '{{ dirvish_vaults }}'
  loop_control:
    label: '{{ item.name }}:{{ item.branch|default("default") }}'

- name: Install the custom Nagios check script
  template:
    dest: /usr/local/bin/check_dirvish
    src: check_dirvish
    owner: root
    mode: 0755
